---
title: '<source>: The Media or Image Source element'
slug: Web/HTML/Element/source
tags:
  - Element
  - HTML
  - HTML embedded content
  - Media
  - Reference
  - Web
  - Web Performance
---
<div>{{HTMLRef}}</div>

<p><span class="seoSummary">The <strong>HTML <code>&lt;source&gt;</code> element</strong> specifies multiple media resources for the {{HTMLElement("picture")}}, the {{HTMLElement("audio")}} element, or the {{HTMLElement("video")}} element.</span> It is an empty element, meaning that it has no content and does not have a closing tag. It is commonly used to offer the same media content in multiple file formats in order to provide compatibility with a broad range of browsers given their differing support for <a href="/en-US/docs/Web/Media/Formats/Image_types">image file formats</a> and <a href="/en-US/docs/Web/Media/Formats">media file formats</a>.</p>

<p>{{EmbedInteractiveExample("pages/tabbed/source.html", "tabbed-standard")}}</p>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples </a> and send us a pull request.</div>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row"><a href="/en-US/docs/Web/Guide/HTML/Content_categories">Content categories</a></th>
   <td>None.</td>
  </tr>
  <tr>
   <th scope="row">Permitted content</th>
   <td>None, it is an {{Glossary("empty element")}}.</td>
  </tr>
  <tr>
   <th scope="row">Tag omission</th>
   <td>It must have a start tag, but must not have an end tag.</td>
  </tr>
  <tr>
   <th scope="row"><dfn>Permitted parents</dfn></th>
   <td>
    <div>A media element—{{HTMLElement("audio")}} or {{HTMLelement("video")}}—and it must be placed before any <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Flow_content">flow content</a> or {{HTMLElement("track")}} element.</div>

    <div>A {{HTMLElement("picture")}} element, and it must be placed before the {{HTMLElement("img")}} element.</div>
   </td>
  </tr>
  <tr>
   <th scope="row">Implicit ARIA role</th>
   <td><a href="https://www.w3.org/TR/html-aria/#dfn-no-corresponding-role">No corresponding role</a></td>
  </tr>
  <tr>
   <th scope="row">Permitted ARIA roles</th>
   <td>No <code>role</code> permitted</td>
  </tr>
  <tr>
   <th scope="row">DOM interface</th>
   <td>{{domxref("HTMLSourceElement")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Attributes">Attributes</h2>

<p>This element includes the <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a>.</p>

<dl>
 <dt>{{htmlattrdef("media")}}</dt>
 <dd><a class="internal" href="/en-US/docs/Web/CSS/Media_Queries">Media query</a> of the resource's intended media; this should be used only in a {{HTMLElement("picture")}} element.</dd>
 <dt>{{htmlattrdef("sizes")}}</dt>
 <dd>
 <p>Is a list of source sizes that describes the final rendered width of the image represented by the source. Each source size consists of a comma-separated list of media condition-length pairs. This information is used by the browser to determine, before laying the page out, which image defined in {{htmlattrxref("srcset", "source")}} to use. Please note that <code>sizes</code> will have its effect only if width dimension descriptors are provided with <code>srcset</code> instead of pixel ratio values (200w instead of 2x for example).</p>

 <p>The <code>sizes</code> attribute has an effect only when the {{HTMLElement("source")}} element is the direct child of a {{HTMLElement("picture")}} element.</p>
 </dd>
 <dt>{{htmlattrdef("src")}}</dt>
 <dd>Required for {{HTMLElement("audio")}} and {{HTMLElement("video")}}, address of the media resource. The value of this attribute is ignored when the <code>&lt;source&gt;</code> element is placed inside a {{HTMLElement("picture")}} element.</dd>
 <dt>{{htmlattrdef("srcset")}}</dt>
 <dd>
 <p>A list of one or more strings separated by commas indicating a set of possible images represented by the source for the browser to use. Each string is composed of:</p>

 <ol>
  <li>One URL specifying an image.</li>
  <li>A width descriptor, which consists of a string containing a positive integer directly followed by <code>"w"</code>, such as <code>300w</code>. The default value, if missing, is the infinity.</li>
  <li>A pixel density descriptor, that is a positive floating number directly followed by <code>"x"</code>. The default value, if missing, is <code>1x</code>.</li>
 </ol>

 <p>Each string in the list must have at least a width descriptor or a pixel density descriptor to be valid. Among the list, there must be only one string containing the same tuple of width descriptor and pixel density descriptor. The browser chooses the most adequate image to display at a given point of time.</p>

 <p>The <code>srcset</code> attribute has an effect only when the {{HTMLElement("source")}} element is the direct child of a {{HTMLElement("picture")}} element.</p>
 </dd>
 <dt>{{htmlattrdef("type")}}</dt>
 <dd>The <a href="/en-US/docs/Web/Media/Formats/Image_types">MIME media type of the resource</a>, optionally with a <a href="/en-US/docs/Web/Media/Formats/codecs_parameter"><code>codecs</code> parameter</a>.</dd>
</dl>

<p>If the <code>type</code> attribute isn't specified, the media's type is retrieved from the server and checked to see if the user agent can handle it; if it can't be rendered, the next <code>&lt;source&gt;</code> is checked. If the <code>type</code> attribute is specified, it's compared against the types the user agent can present, and if it's not recognized, the server doesn't even get queried; instead, the next <code>&lt;source&gt;</code> element is checked at once.</p>

<p>When used in the context of a <code>&lt;picture&gt;</code> element, the browser will fall back to using the image specified by the <code>&lt;picture&gt;</code> element's {{HTMLElement("img")}} child if it is unable to find a suitable image to use after examining every provided <code>&lt;source&gt;</code>.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>The <code>&lt;source&gt;</code> element is an <strong>empty element (or void element)</strong>, which means that it not only has no content but also has no closing tag. That is, you <em>never</em> use "<code>&lt;/source&gt;</code>" in your HTML.</p>

<p>For information about image formats supported by web browsers and guidance on selecting appropriate formats to use, see our <a href="/en-US/docs/Web/Media/Formats/Image_types">Image file type and format guide</a> on the web. For details on the video and audio media types, you can use, see the <a href="/en-US/docs/Web/Media/Formats">Guide to media types formats used on the web</a>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Video_example">Video example</h3>

<p>This example demonstrates how to offer a video in Ogg format for users whose browsers support Ogg format, and a QuickTime format video for users whose browsers support that. If the <code>audio</code> or <code>video</code> element is not supported by the browser, a notice is displayed instead. If the browser supports the element but does not support any of the specified formats, an <code>error</code> event is raised and the default media controls (if enabled) will indicate an error. Be sure to reference our <a href="/en-US/docs/Web/Media/Formats">guide to media types and formats on the web</a> for details on what media file formats you can use and how well they're supported by browsers.</p>

<pre class="brush: html notranslate">&lt;video controls&gt;
  &lt;source src="foo.webm" type="video/webm"&gt;
  &lt;source src="foo.ogg" type="video/ogg"&gt;
  &lt;source src="foo.mov" type="video/quicktime"&gt;
  I'm sorry; your browser doesn't support HTML5 video.
&lt;/video&gt;
</pre>

<p>For more examples, the learning area article <a href="/en-US/docs/Learn/HTML/Multimedia_and_embedding/Video_and_audio_content">Video and audio content</a> is a great resource.</p>

<h3 id="Picture_example">Picture example</h3>

<p>In this example, two <code>&lt;source&gt;</code> elements are included within the {{HTMLElement("picture")}}, providing versions of an image to use when the available space exceeds certain widths. If the available width is less than the smaller of these widths, the user agent will fall back to the image given by the {{HTMLElement("img")}} element.</p>

<pre class="brush: html notranslate">&lt;picture&gt;
   &lt;source srcset="mdn-logo-wide.png" media="(min-width: 800px)"&gt;
   &lt;source srcset="mdn-logo-medium.png" media="(min-width: 600px)"&gt;
   &lt;img src="mdn-logo-narrow.png" alt="MDN Web Docs"&gt;
&lt;/picture&gt;
</pre>

<p>With the <code>&lt;picture&gt;</code> element, you must always include an <code>&lt;<a href="/en-US/docs/Web/HTML/Element/img">img</a>&gt;</code> with a fallback image, with an <code>alt</code> attribute to ensure accessibility (unless the image is an irrelevant background decorative image).</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'embedded-content.html#the-source-element', '&lt;source&gt;')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.source")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Media/Formats">Guide to media types and formats on the web</a></li>
 <li><a href="/en-US/docs/Web/Media/Formats/Image_types">Image file type and format guide</a></li>
 <li>{{HTMLElement("picture")}} element</li>
 <li>{{HTMLElement("audio")}} element</li>
 <li>{{HTMLElement("video")}} element</li>
 <li><a href="/en-US/docs/Learn/Performance">Web Performance</a></li>
</ul>
